using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Algorithm;

using ClassLibrary;

namespace Sistemi_informativi_LS
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonSimilarity;
		private System.Windows.Forms.Button buttonContains;
		private System.Windows.Forms.Button buttonPartOf;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.PictureBox pictureBox3;
		private System.Windows.Forms.PictureBox pictureBox4;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.NumericUpDown numericUpDown1;
		private System.Windows.Forms.ProgressBar progressBar1;
		private System.Windows.Forms.Button buttonRefresh;
		private System.ComponentModel.Container components = null;

		// miei
		private ImageImpl2 _currentImage;
		private System.Windows.Forms.PictureBox pictureBox5;
		private System.Windows.Forms.PictureBox pictureBox6;
		private System.Windows.Forms.PictureBox pictureBox7;
		private System.Windows.Forms.NumericUpDown numericUpDown_K;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label labelResult;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label labelAutori;
		private ImageDBManager _dbManager = new ImageDBManager("..\\..\\resources");


		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			pictureBox1.SizeMode = PictureBoxSizeMode.StretchImage ;
			pictureBox2.SizeMode = PictureBoxSizeMode.StretchImage ;
			pictureBox3.SizeMode = PictureBoxSizeMode.StretchImage ;
			pictureBox4.SizeMode = PictureBoxSizeMode.StretchImage ;
			pictureBox5.SizeMode = PictureBoxSizeMode.StretchImage ;
			pictureBox6.SizeMode = PictureBoxSizeMode.StretchImage ;
			pictureBox7.SizeMode = PictureBoxSizeMode.StretchImage ;

			// mio
			Utility.Progress += new EventHandler(Utility_Progress);
			this._dbManager.Progress += new EventHandler(Utility_Progress);
			this.labelAutori.Text = "AUTORI:\n- Galli Laura\n- Sacchetti Mauro\n- Samorani Michele";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Restituisce il numero di regioni in cui
		/// dividere l'immagine
		/// </summary>
		/// <returns></returns>
		private int GetNRegions()
		{
			if (this.radioButton1.Checked)
				return 4;
			if (this.radioButton2.Checked)
				return 5;
			else
				return 0;
		}

		private int GetNIntervalsRGB()
		{
			decimal d = this.numericUpDown1.Value;
			return (int)d;
		}

		private int GetK()
		{
			return (int)(this.numericUpDown_K.Value);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.buttonSimilarity = new System.Windows.Forms.Button();
			this.buttonContains = new System.Windows.Forms.Button();
			this.buttonPartOf = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label2 = new System.Windows.Forms.Label();
			this.numericUpDown_K = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.radioButton2 = new System.Windows.Forms.RadioButton();
			this.radioButton1 = new System.Windows.Forms.RadioButton();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.pictureBox3 = new System.Windows.Forms.PictureBox();
			this.pictureBox4 = new System.Windows.Forms.PictureBox();
			this.progressBar1 = new System.Windows.Forms.ProgressBar();
			this.buttonRefresh = new System.Windows.Forms.Button();
			this.pictureBox5 = new System.Windows.Forms.PictureBox();
			this.pictureBox6 = new System.Windows.Forms.PictureBox();
			this.pictureBox7 = new System.Windows.Forms.PictureBox();
			this.labelResult = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.labelAutori = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown_K)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
			this.SuspendLayout();
			// 
			// pictureBox2
			// 
			this.pictureBox2.Location = new System.Drawing.Point(0, 272);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(208, 144);
			this.pictureBox2.TabIndex = 0;
			this.pictureBox2.TabStop = false;
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(8, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(272, 176);
			this.pictureBox1.TabIndex = 1;
			this.pictureBox1.TabStop = false;
			// 
			// buttonSimilarity
			// 
			this.buttonSimilarity.Location = new System.Drawing.Point(32, 216);
			this.buttonSimilarity.Name = "buttonSimilarity";
			this.buttonSimilarity.TabIndex = 2;
			this.buttonSimilarity.Text = "Similarity";
			this.buttonSimilarity.Click += new System.EventHandler(this.buttonSimilarity_Click);
			// 
			// buttonContains
			// 
			this.buttonContains.Location = new System.Drawing.Point(272, 216);
			this.buttonContains.Name = "buttonContains";
			this.buttonContains.TabIndex = 3;
			this.buttonContains.Text = "Contains";
			this.buttonContains.Click += new System.EventHandler(this.buttonContains_Click);
			// 
			// buttonPartOf
			// 
			this.buttonPartOf.Location = new System.Drawing.Point(160, 216);
			this.buttonPartOf.Name = "buttonPartOf";
			this.buttonPartOf.TabIndex = 4;
			this.buttonPartOf.Text = "Part-Of";
			this.buttonPartOf.Click += new System.EventHandler(this.buttonPartOf_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.numericUpDown_K);
			this.groupBox1.Controls.Add(this.numericUpDown1);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.radioButton2);
			this.groupBox1.Controls.Add(this.radioButton1);
			this.groupBox1.Location = new System.Drawing.Point(296, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(192, 200);
			this.groupBox1.TabIndex = 5;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "opzioni";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 168);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(24, 16);
			this.label2.TabIndex = 6;
			this.label2.Text = "k";
			// 
			// numericUpDown_K
			// 
			this.numericUpDown_K.Location = new System.Drawing.Point(48, 168);
			this.numericUpDown_K.Maximum = new System.Decimal(new int[] {
																			6,
																			0,
																			0,
																			0});
			this.numericUpDown_K.Minimum = new System.Decimal(new int[] {
																			1,
																			0,
																			0,
																			0});
			this.numericUpDown_K.Name = "numericUpDown_K";
			this.numericUpDown_K.Size = new System.Drawing.Size(32, 20);
			this.numericUpDown_K.TabIndex = 5;
			this.numericUpDown_K.Value = new System.Decimal(new int[] {
																		  6,
																		  0,
																		  0,
																		  0});
			// 
			// numericUpDown1
			// 
			this.numericUpDown1.Location = new System.Drawing.Point(152, 112);
			this.numericUpDown1.Minimum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   0});
			this.numericUpDown1.Name = "numericUpDown1";
			this.numericUpDown1.Size = new System.Drawing.Size(32, 20);
			this.numericUpDown1.TabIndex = 4;
			this.numericUpDown1.Value = new System.Decimal(new int[] {
																		 4,
																		 0,
																		 0,
																		 0});
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 112);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(128, 32);
			this.label1.TabIndex = 3;
			this.label1.Text = "Intervalli di divisione RGB";
			// 
			// radioButton2
			// 
			this.radioButton2.Checked = true;
			this.radioButton2.Location = new System.Drawing.Point(8, 64);
			this.radioButton2.Name = "radioButton2";
			this.radioButton2.TabIndex = 1;
			this.radioButton2.TabStop = true;
			this.radioButton2.Text = "5 regioni";
			// 
			// radioButton1
			// 
			this.radioButton1.Location = new System.Drawing.Point(8, 32);
			this.radioButton1.Name = "radioButton1";
			this.radioButton1.TabIndex = 0;
			this.radioButton1.Text = "4 regioni";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2});
			this.menuItem1.Text = "File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "Carica immagine query";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.InitialDirectory = "..\\..\\resources";
			// 
			// pictureBox3
			// 
			this.pictureBox3.Location = new System.Drawing.Point(224, 272);
			this.pictureBox3.Name = "pictureBox3";
			this.pictureBox3.Size = new System.Drawing.Size(208, 144);
			this.pictureBox3.TabIndex = 6;
			this.pictureBox3.TabStop = false;
			// 
			// pictureBox4
			// 
			this.pictureBox4.Location = new System.Drawing.Point(448, 272);
			this.pictureBox4.Name = "pictureBox4";
			this.pictureBox4.Size = new System.Drawing.Size(224, 144);
			this.pictureBox4.TabIndex = 7;
			this.pictureBox4.TabStop = false;
			// 
			// progressBar1
			// 
			this.progressBar1.Location = new System.Drawing.Point(0, 184);
			this.progressBar1.Name = "progressBar1";
			this.progressBar1.Size = new System.Drawing.Size(288, 23);
			this.progressBar1.Step = 5;
			this.progressBar1.TabIndex = 8;
			// 
			// buttonRefresh
			// 
			this.buttonRefresh.Location = new System.Drawing.Point(424, 216);
			this.buttonRefresh.Name = "buttonRefresh";
			this.buttonRefresh.Size = new System.Drawing.Size(112, 23);
			this.buttonRefresh.TabIndex = 10;
			this.buttonRefresh.Text = "refresh DB";
			this.buttonRefresh.Click += new System.EventHandler(this.buttonRefresh_Click);
			// 
			// pictureBox5
			// 
			this.pictureBox5.Location = new System.Drawing.Point(8, 472);
			this.pictureBox5.Name = "pictureBox5";
			this.pictureBox5.Size = new System.Drawing.Size(200, 152);
			this.pictureBox5.TabIndex = 11;
			this.pictureBox5.TabStop = false;
			// 
			// pictureBox6
			// 
			this.pictureBox6.Location = new System.Drawing.Point(232, 472);
			this.pictureBox6.Name = "pictureBox6";
			this.pictureBox6.Size = new System.Drawing.Size(200, 152);
			this.pictureBox6.TabIndex = 12;
			this.pictureBox6.TabStop = false;
			// 
			// pictureBox7
			// 
			this.pictureBox7.Location = new System.Drawing.Point(448, 472);
			this.pictureBox7.Name = "pictureBox7";
			this.pictureBox7.Size = new System.Drawing.Size(224, 152);
			this.pictureBox7.TabIndex = 13;
			this.pictureBox7.TabStop = false;
			// 
			// labelResult
			// 
			this.labelResult.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelResult.Location = new System.Drawing.Point(744, 352);
			this.labelResult.Name = "labelResult";
			this.labelResult.Size = new System.Drawing.Size(176, 168);
			this.labelResult.TabIndex = 14;
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(104, 424);
			this.label3.Name = "label3";
			this.label3.TabIndex = 15;
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(336, 424);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(96, 23);
			this.label4.TabIndex = 16;
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Location = new System.Drawing.Point(568, 424);
			this.label5.Name = "label5";
			this.label5.TabIndex = 17;
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.Location = new System.Drawing.Point(104, 632);
			this.label6.Name = "label6";
			this.label6.TabIndex = 18;
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label7.Location = new System.Drawing.Point(328, 632);
			this.label7.Name = "label7";
			this.label7.TabIndex = 19;
			// 
			// label8
			// 
			this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label8.Location = new System.Drawing.Point(568, 632);
			this.label8.Name = "label8";
			this.label8.TabIndex = 20;
			// 
			// labelAutori
			// 
			this.labelAutori.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelAutori.Location = new System.Drawing.Point(576, 16);
			this.labelAutori.Name = "labelAutori";
			this.labelAutori.Size = new System.Drawing.Size(160, 64);
			this.labelAutori.TabIndex = 21;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(920, 657);
			this.Controls.Add(this.labelAutori);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.labelResult);
			this.Controls.Add(this.pictureBox7);
			this.Controls.Add(this.pictureBox6);
			this.Controls.Add(this.pictureBox5);
			this.Controls.Add(this.buttonRefresh);
			this.Controls.Add(this.progressBar1);
			this.Controls.Add(this.pictureBox4);
			this.Controls.Add(this.pictureBox3);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.buttonPartOf);
			this.Controls.Add(this.buttonContains);
			this.Controls.Add(this.buttonSimilarity);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.pictureBox2);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Efficient Region-Based Image Retrieval";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown_K)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

//		protected void Println (string s)
//		{
//			this.richTextBox1.Text += s;
//		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Form1 f1 = new Form1();
			Application.Run(f1);
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			openFileDialog1.ShowDialog();
			string f = openFileDialog1.FileName;
			DisplayImage(f);
		}

		protected void DisplayImage (string nomeFile)
		{
			this.progressBar1.Value=0;

			try
			{
				Bitmap bitmap = new Bitmap(nomeFile);
				this.pictureBox1.Image = bitmap;
//				bitmap.Dispose();

				this._currentImage = new ImageImpl2(nomeFile,this.GetNRegions(),this.GetNIntervalsRGB());
				_currentImage.Progress += new EventHandler(Utility_Progress);
				_currentImage.ComputeRegions();
				_currentImage.DisposeBitmap();
//				
//
//				Println(im.ToString());			
			}
			catch (Exception e)
			{
				MessageBox.Show("Devi scegliere un'immagine");
				return;
			}

			this.progressBar1.Value=0;
		}

		private void buttonRefresh_Click(object sender, System.EventArgs e)
		{
			DisableInput();
			this.progressBar1.Value = 0;
			_dbManager.Reset();
			_dbManager.LoadAll(this.GetNRegions(),this.GetNIntervalsRGB());
			EnableInput();
			this.progressBar1.Value = 0;
		}

		private void Utility_Progress(object sender, System.EventArgs e)
		{
			this.progressBar1.Increment(5);
		}

		// invoca Algorithm.Compute se c' una query e se il DB  stato inizializzato
		private void buttonSimilarity_Click(object sender, System.EventArgs e)
		{
			ComputeQuery(0);
		}

		private void buttonPartOf_Click(object sender, System.EventArgs e)
		{
			ComputeQuery(1);
		}

		private void buttonContains_Click(object sender, System.EventArgs e)
		{
			ComputeQuery(2);
		}

		/*
		 * TIPI:
		 * 
		 * 0:
		 * 1:
		 * 2:
		 */
		private void ComputeQuery (int type)
		{
			int k = GetK();

			ElementCollection result = new ElementCollection();

			// se non  caricata l'immagine query o il DB non  stato inizializzato esci
			if (this._currentImage != null && this._dbManager.GetImages().Length > 0)
			{
//				Println("--------- RISULTATO ---------\n");
				result = Algorithm.Algorithm.Compute(_currentImage,this._dbManager.GetImages(),k,type);

//				foreach (Element e in result)
//				{
//					Println("- "+e.Image.GetId()+": "+e.Image.GetName()+ " ---> "+e.Distanza+"\n");
//				}
				try
				{
					ResetImages();

					int i = 0;

					while (true)
					{
						// metti immagini nuove
						this.pictureBox2.Image = new Bitmap(result[0].Image.GetName());
						this.label3.Text = "d= "+result[0].Distanza;
						if (++i >= k) break;

						this.pictureBox3.Image = new Bitmap(result[1].Image.GetName());
						this.label4.Text = "d= "+result[1].Distanza;
						if (++i >= k) break;

						this.pictureBox4.Image = new Bitmap(result[2].Image.GetName());
						this.label5.Text = "d= "+result[2].Distanza;
						if (++i >= k) break;

						this.pictureBox5.Image = new Bitmap(result[3].Image.GetName());
						this.label6.Text = "d= "+result[3].Distanza;
						if (++i >= k) break;

						this.pictureBox6.Image = new Bitmap(result[4].Image.GetName());
						this.label7.Text = "d= "+result[4].Distanza;
						if (++i >= k) break;

						this.pictureBox7.Image = new Bitmap(result[5].Image.GetName());
						this.label8.Text = "d= "+result[5].Distanza;
						if (++i >= k) break;
					}
				}
				catch (Exception e) {}
				this.labelResult.Text = "Algoritmo ungherese chiamato per \n\n"+result.Count+
					"/" + this._dbManager.NumFilesInDb + " immagini";
			}
		}

		// cancella immagini e label
		private void ResetImages()
		{
			// cancella immagini
			this.pictureBox2.Image = null;
			this.pictureBox3.Image = null;
			this.pictureBox4.Image = null;
			this.pictureBox5.Image = null;
			this.pictureBox6.Image = null;
			this.pictureBox7.Image = null;

			// cancella label
			this.label3.Text = "";
			this.label4.Text = "";
			this.label5.Text = "";
			this.label6.Text = "";
			this.label7.Text = "";
			this.label8.Text = "";
		}
		// disabilita tutti gli input
		private void DisableInput()
		{
			this.buttonContains.Enabled = false;
			this.buttonPartOf.Enabled = false;
			this.buttonRefresh.Enabled = false;
			this.buttonSimilarity.Enabled = false;
			this.menuItem1.Enabled = false;
			this.groupBox1.Enabled = false;
		}

	
	
		// abilita tutti gli input
		private void EnableInput()
		{
			this.buttonContains.Enabled = true;
			this.buttonPartOf.Enabled = true;
			this.buttonRefresh.Enabled = true;
			this.buttonSimilarity.Enabled = true;
			this.menuItem1.Enabled = true;
			this.groupBox1.Enabled = true;
		}
	}
}
