using System;
using NUnit.Framework;
using ClassLibrary;
using System.Drawing;

/*
 * Per usare funzioni C:
 
 * 1) dichiarare l'esportazione nel file .h dove si trova la funzione da esportare
 * 
 *	   extern __declspec(dllexport) int manhattan_nD(int *f1, int *f2,int n);
 * 
 * 
 * 2) nel  file C# dove voglio chiamare questa funzione, dichiaro un metodo statico
 *    con lo stesso nome e parametri corrispondenti e gli metto l'attributo di
 *	  importazione:
 * 
 * 		[System.Runtime.InteropServices.DllImport("CLib")]
 *		private static extern int manhattan_nD(int[] arr1, int[] arr2, int i);
 *
 *
 * 3) copiare nella cartella debug del main (nel progetto C# quindi)
 *    la dll generata che si trova nel progetto C
 */

namespace Test
{
	[TestFixture]
	public class ClassTest
	{

		[Test]
		public void testUtilityGetMatrix()
		{
			Bitmap map = new Bitmap("..\\..\\olimpia.jpg");
			Utility.ComputeMatrix(map,4,4);
			
		}

		[System.Runtime.InteropServices.DllImport("CLib")]
		private static extern int hungarian (int [] matr, int rows, int cols);


		[Test]
		public void testCLibrary()
		{
			int [] array = new int[] {10,0,0,0,5,6,7,8,9};
			int result = hungarian(array,3,3);
			Console.WriteLine(result);
		}
	}
}
